# publish both npm package and docker build

# Publish npm package if commit has a version tag or is production branch.
# Publish only if version changed.
# Publish tagged "beta" if version contains beta (e.g. v2.0.0-beta.0)
#
# The original template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/npm.gitlab-ci.yml

build-site:
  image: node:latest
  stage: build
  rules:
    - if: $CI_COMMIT_REF_NAME =~ /^v\d+\.\d+\.\d+.*$/ || $API_JOB_NAME == $CI_JOB_NAME
  script:
    - npm install --progress=false
    - npm run build
  artifacts:
    expire_in: 1 week
    name: $CI_COMMIT_REF_NAME
    paths:
      - dist

# Build a Docker image with CI/CD and push to the GitLab registry.
# Docker-in-Docker documentation: https://docs.gitlab.com/ee/ci/docker/using_docker_build.html
#
# This template uses one generic job with conditional builds
# for the default branch and all other (MR) branches.

docker-build:
  # Use the official docker image.
  image: docker:latest
  stage: build
  # Run this job for tags only. If tag is version number, build 'latest' container also (tag like v0.0.0)
  only:
    - tags
  services:
    - docker:dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  # tagged with production version number (commit tag)
  script:
    - docker build --pull -t "$CI_REGISTRY_IMAGE" -t "$CI_REGISTRY_IMAGE:${CI_COMMIT_TAG}" .
    - VERSION_PATTERN="^v([0-9]+\.){0,2}(\*|[0-9]+)$"
    - |
      if [[ "$CI_COMMIT_TAG" =~ $VERSION_PATTERN ]]; then
        docker push "$CI_REGISTRY_IMAGE"
        echo "Tag is version number. Build also with tag 'latest'"
      else
        echo "Tag '$CI_COMMIT_TAG' is not a valid version number. Push with tag '$CI_COMMIT_TAG' only"
      fi
    - docker push "$CI_REGISTRY_IMAGE:${CI_COMMIT_TAG}"
